// deNetWinServer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "deNetWinServer.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDeNetWinServerApp

BEGIN_MESSAGE_MAP(CDeNetWinServerApp, CWinApp)
	//{{AFX_MSG_MAP(CDeNetWinServerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_CREATE_SERVER, OnCreateServer)
	ON_UPDATE_COMMAND_UI(ID_CREATE_SERVER, OnUpdateCreateServer)
	ON_COMMAND(ID_DISCONNECT, OnDisconnect)
	ON_UPDATE_COMMAND_UI(ID_DISCONNECT, OnUpdateDisconnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeNetWinServerApp construction

// found in MessageDiag.cpp
DWORD OnNetLog( const char * pStr );

CDeNetWinServerApp::CDeNetWinServerApp()
{
	
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDeNetWinServerApp object

CDeNetWinServerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDeNetWinServerApp initialization

BOOL CDeNetWinServerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));


	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create and load the frame with its resources

	pFrame->LoadFrame(IDR_MAINFRAME,
		WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE, NULL,
		NULL);




	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);
	pFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDeNetWinServerApp message handlers





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDeNetWinServerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDeNetWinServerApp message handlers


void CDeNetWinServerApp::OnCreateServer() 
{
	// init server
	eNetError r = CODE_OK;
	r = m_Server.Init( deConnection::TYPE_TCP, NULL );

	if( r == CODE_OK )
	{
		m_Server.CreateServer();
		CMessageDiag::GetWin()->ClearMessages();
	}
}

void CDeNetWinServerApp::OnUpdateCreateServer(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

void CDeNetWinServerApp::OnDisconnect() 
{
	m_Server.Destroy( NULL );
}

void CDeNetWinServerApp::OnUpdateDisconnect(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

BOOL CDeNetWinServerApp::InitApplication() 
{
	if( CWinApp::InitApplication() )
	{
		eNetError r = CODE_OK;

		r = deNet_Startup( 256, 64 );
		
		if( r == CODE_OK )
		{
			deNet_SetOnLogHandler( OnNetLog );
			deNet_SetAppName( "deNetTest.cpp" );
		}

		if( r == CODE_OK )
			return TRUE;
		else
			return FALSE;
	}
	else
		return FALSE;
}

void CDeNetWinServerApp::OnFinalRelease() 
{
	CWinApp::OnFinalRelease();
}

int CDeNetWinServerApp::ExitInstance() 
{
	// shut it down
	m_Server.Destroy( NULL );
	deNet_Shutdown( NULL );
	deNet_SetOnLogHandler( NULL );
	
	return CWinApp::ExitInstance();
}
